/*******************************************************************************
 * University of Illinois/NCSA
 * Open Source License
 *
 * Copyright (c) 2010 , NCSA.  All rights reserved.
 *
 * Developed by:
 * Cyberenvironments and Technologies (CET)
 * http://cet.ncsa.illinois.edu/
 *
 * National Center for Supercomputing Applications (NCSA)
 * http://www.ncsa.illinois.edu/
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal with the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimers.
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in the
 *   documentation and/or other materials provided with the distribution.
 * - Neither the names of CET, University of Illinois/NCSA, nor the names
 *   of its contributors may be used to endorse or promote products
 *   derived from this Software without specific prior written permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 *******************************************************************************/
package edu.uiuc.ncsa.cet.bean;

import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

public class TagEventBean extends CETBean {

	private static final long serialVersionUID = 1L;

	/** creator of the tag event */
	private PersonBean tagCreator = null;

	/** Time at which event was created */
	private Date tagEventDate = null;

	/** Tags associated with this event */
	private Set<TagBean> tags = new HashSet<TagBean>();

	/** Resource to which event is associated* */
	private CETBean resource;

	public PersonBean getTagCreator() {
		return tagCreator;
	}

	public void setTagCreator(PersonBean tagCreator) {
		this.tagCreator = tagCreator;
	}

	public Date getTagEventDate() {
		return tagEventDate;
	}

	public void setTagEventDate(Date tagEventDate) {
		this.tagEventDate = tagEventDate;
	}

	public Set<TagBean> getTags() {
		return tags;
	}

	public void setTags(Collection<TagBean> tags) {
		this.tags.clear();
		if (tags != null) {
			this.tags.addAll(tags);
		}
	}

	public void addTag(TagBean tag) {
		if (tag != null) {
			this.tags.add(tag);
		}
	}

	public void removeTag(TagBean tag) {
		this.tags.remove(tag);
	}

	public CETBean getResource() {
		return resource;
	}

	public void setResource(CETBean resource) {
		this.resource = resource;
	}
}
